/**
 * @file
 * @brief     Generated functions to emit code for assembler ir nodes.
 * @note      DO NOT EDIT THIS FILE, your changes will be lost.
 *            Edit libfirm/ir/be/amd64/amd64_spec.pl instead.
 *            created by: libfirm/ir/be/scripts/generate_emitter.pl libfirm/ir/be/amd64/amd64_spec.pl libfirm/ir/be/amd64
 * @date      Tue May 10 19:36:45 2011
 */
#include "config.h"

#include <stdio.h>

#include "irnode.h"
#include "irop_t.h"
#include "irprog_t.h"
#include "../beemitter.h"

#include "gen_amd64_emitter.h"
#include "amd64_new_nodes.h"
#include "amd64_emitter.h"

static void emit_amd64_Store(const ir_node *node) {
	be_emit_cstring("\tmov ");
	amd64_emit_source_register(node, 1);
	be_emit_cstring(", ");
	amd64_emit_fp_offset(node);
	be_emit_char('(');
	amd64_emit_source_register(node, 0);
	be_emit_char(')');
	be_emit_finish_line_gas(node);
}

static void emit_amd64_Immediate(const ir_node *node) {
	be_emit_cstring("\tmov ");
	amd64_emit_immediate(node);
	be_emit_cstring(", ");
	amd64_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_amd64_Push(const ir_node *node) {
	be_emit_cstring("\tpush ");
	amd64_emit_source_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_amd64_Neg(const ir_node *node) {
	be_emit_cstring("\tneg ");
	amd64_emit_source_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_amd64_Cmp(const ir_node *node) {
	be_emit_cstring("\tcmp ");
	amd64_emit_source_register(node, 0);
	be_emit_cstring(", ");
	amd64_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_amd64_Load(const ir_node *node) {
	be_emit_cstring("\tmov ");
	amd64_emit_fp_offset(node);
	be_emit_char('(');
	amd64_emit_source_register(node, 0);
	be_emit_cstring("), ");
	amd64_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_amd64_Mul(const ir_node *node) {
	be_emit_cstring("\tmul ");
	amd64_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

/**
 * Enters the emitter functions for handled nodes into the generic
 * pointer of an opcode.
 */
void amd64_register_spec_emitters(void) {

#define BE_EMIT(a) op_amd64_##a->ops.generic = (op_func)emit_amd64_##a

  /* generated emitter functions */
  BE_EMIT(Store);
  BE_EMIT(Immediate);
  BE_EMIT(Push);
  BE_EMIT(Neg);
  BE_EMIT(Cmp);
  BE_EMIT(Load);
  BE_EMIT(Mul);

#undef BE_EMIT
}

