/**
 * @file
 * @brief     Generated functions to emit code for assembler ir nodes.
 * @note      DO NOT EDIT THIS FILE, your changes will be lost.
 *            Edit libfirm/ir/be/arm/arm_spec.pl instead.
 *            created by: libfirm/ir/be/scripts/generate_emitter.pl libfirm/ir/be/arm/arm_spec.pl libfirm/ir/be/arm
 * @date      Tue May 10 19:36:47 2011
 */
#include "config.h"

#include <stdio.h>

#include "irnode.h"
#include "irop_t.h"
#include "irprog_t.h"
#include "../beemitter.h"

#include "gen_arm_emitter.h"
#include "arm_new_nodes.h"
#include "arm_emitter.h"

static void emit_arm_Mvf(const ir_node *node) {
	be_emit_cstring("\tmvf");
	arm_emit_float_arithmetic_mode(node);
	be_emit_char(' ');
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Ldr(const ir_node *node) {
	be_emit_cstring("\tldr");
	arm_emit_load_mode(node);
	be_emit_char(' ');
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", [");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", #");
	arm_emit_offset(node);
	be_emit_char(']');
	be_emit_finish_line_gas(node);
}

static void emit_arm_Rsb(const ir_node *node) {
	be_emit_cstring("\trsb ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Mla(const ir_node *node) {
	be_emit_cstring("\tmla ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 1);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 2);
	be_emit_finish_line_gas(node);
}

static void emit_arm_LinkMovPC(const ir_node *node) {
	be_emit_cstring("\tmov lr, pc");
	be_emit_finish_line_gas(node);
	be_emit_cstring("\tmov pc, ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Mov(const ir_node *node) {
	be_emit_cstring("\tmov ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_FltX(const ir_node *node) {
	be_emit_cstring("\tflt");
	arm_emit_float_arithmetic_mode(node);
	be_emit_char(' ');
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Or(const ir_node *node) {
	be_emit_cstring("\torr ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_EmptyReg(const ir_node *node) {
	be_emit_cstring("\t/* ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(" now available for calculations */");
	be_emit_finish_line_gas(node);
}

static void emit_arm_Cmp(const ir_node *node) {
	be_emit_cstring("\tcmp ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Smull(const ir_node *node) {
	be_emit_cstring("\tsmull ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_dest_register(node, 1);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Add(const ir_node *node) {
	be_emit_cstring("\tadd ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_LinkLdrPC(const ir_node *node) {
	be_emit_cstring("\tmov lr, pc");
	be_emit_finish_line_gas(node);
	be_emit_cstring("\tldr pc, ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Ldf(const ir_node *node) {
	be_emit_cstring("\tldf");
	arm_emit_float_load_store_mode(node);
	be_emit_char(' ');
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", [");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", #");
	arm_emit_offset(node);
	be_emit_char(']');
	be_emit_finish_line_gas(node);
}

static void emit_arm_Mvn(const ir_node *node) {
	be_emit_cstring("\tmvn ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_LoadStackM3Epilogue(const ir_node *node) {
	be_emit_cstring("\tldmfd ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", {");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_dest_register(node, 1);
	be_emit_cstring(", ");
	arm_emit_dest_register(node, 2);
	be_emit_char('}');
	be_emit_finish_line_gas(node);
}

static void emit_arm_Tst(const ir_node *node) {
	be_emit_cstring("\ttst ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Umull(const ir_node *node) {
	be_emit_cstring("\tumull ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_dest_register(node, 1);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Bic(const ir_node *node) {
	be_emit_cstring("\tbic ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Sub(const ir_node *node) {
	be_emit_cstring("\tsub ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Mul(const ir_node *node) {
	be_emit_cstring("\tmul ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Adf(const ir_node *node) {
	be_emit_cstring("\tadf");
	arm_emit_float_arithmetic_mode(node);
	be_emit_char(' ');
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Bl(const ir_node *node) {
	be_emit_cstring("\tbl ");
	arm_emit_symconst(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Stf(const ir_node *node) {
	be_emit_cstring("\tstf");
	arm_emit_float_load_store_mode(node);
	be_emit_char(' ');
	arm_emit_source_register(node, 1);
	be_emit_cstring(", [");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", #");
	arm_emit_offset(node);
	be_emit_char(']');
	be_emit_finish_line_gas(node);
}

static void emit_arm_Clz(const ir_node *node) {
	be_emit_cstring("\tclz ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Suf(const ir_node *node) {
	be_emit_cstring("\tsuf");
	arm_emit_float_arithmetic_mode(node);
	be_emit_char(' ');
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Cmfe(const ir_node *node) {
	be_emit_cstring("\tcmfe ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_arm_And(const ir_node *node) {
	be_emit_cstring("\tand ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Str(const ir_node *node) {
	be_emit_cstring("\tstr");
	arm_emit_store_mode(node);
	be_emit_char(' ');
	arm_emit_source_register(node, 1);
	be_emit_cstring(", [");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", #");
	arm_emit_offset(node);
	be_emit_char(']');
	be_emit_finish_line_gas(node);
}

static void emit_arm_Dvf(const ir_node *node) {
	be_emit_cstring("\tdvf");
	arm_emit_float_arithmetic_mode(node);
	be_emit_char(' ');
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_arm_StoreStackM4Inc(const ir_node *node) {
	be_emit_cstring("\tstmfd ");
	arm_emit_source_register(node, 0);
	be_emit_cstring("!, {");
	arm_emit_source_register(node, 1);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 2);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 3);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 4);
	be_emit_char('}');
	be_emit_finish_line_gas(node);
}

static void emit_arm_Muf(const ir_node *node) {
	be_emit_cstring("\tmuf");
	arm_emit_float_arithmetic_mode(node);
	be_emit_char(' ');
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_arm_Eor(const ir_node *node) {
	be_emit_cstring("\teor ");
	arm_emit_dest_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_source_register(node, 0);
	be_emit_cstring(", ");
	arm_emit_shifter_operand(node);
	be_emit_finish_line_gas(node);
}

/**
 * Enters the emitter functions for handled nodes into the generic
 * pointer of an opcode.
 */
void arm_register_spec_emitters(void) {

#define BE_EMIT(a) op_arm_##a->ops.generic = (op_func)emit_arm_##a

  /* generated emitter functions */
  BE_EMIT(Mvf);
  BE_EMIT(Ldr);
  BE_EMIT(Rsb);
  BE_EMIT(Mla);
  BE_EMIT(LinkMovPC);
  BE_EMIT(Mov);
  BE_EMIT(FltX);
  BE_EMIT(Or);
  BE_EMIT(EmptyReg);
  BE_EMIT(Cmp);
  BE_EMIT(Smull);
  BE_EMIT(Add);
  BE_EMIT(LinkLdrPC);
  BE_EMIT(Ldf);
  BE_EMIT(Mvn);
  BE_EMIT(LoadStackM3Epilogue);
  BE_EMIT(Tst);
  BE_EMIT(Umull);
  BE_EMIT(Bic);
  BE_EMIT(Sub);
  BE_EMIT(Mul);
  BE_EMIT(Adf);
  BE_EMIT(Bl);
  BE_EMIT(Stf);
  BE_EMIT(Clz);
  BE_EMIT(Suf);
  BE_EMIT(Cmfe);
  BE_EMIT(And);
  BE_EMIT(Str);
  BE_EMIT(Dvf);
  BE_EMIT(StoreStackM4Inc);
  BE_EMIT(Muf);
  BE_EMIT(Eor);

#undef BE_EMIT
}

