/**
 * @file
 * @brief     Generated functions to emit code for assembler ir nodes.
 * @note      DO NOT EDIT THIS FILE, your changes will be lost.
 *            Edit libfirm/ir/be/sparc/sparc_spec.pl instead.
 *            created by: libfirm/ir/be/scripts/generate_emitter.pl libfirm/ir/be/sparc/sparc_spec.pl libfirm/ir/be/sparc
 * @date      Tue May 17 19:12:30 2011
 */
#include "config.h"

#include <stdio.h>

#include "irnode.h"
#include "irop_t.h"
#include "irprog_t.h"
#include "../beemitter.h"

#include "gen_sparc_emitter.h"
#include "sparc_new_nodes.h"
#include "sparc_emitter.h"

static void emit_sparc_Sra(const ir_node *node) {
	be_emit_cstring("\tsra ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Ld(const ir_node *node) {
	be_emit_cstring("\tld");
	sparc_emit_load_mode(node);
	be_emit_cstring(" [");
	sparc_emit_source_register(node, 0);
	sparc_emit_offset(node, 1);
	be_emit_cstring("], ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fitof(const ir_node *node) {
	be_emit_cstring("\tfito");
	sparc_emit_fp_mode_suffix(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fadd(const ir_node *node) {
	be_emit_cstring("\tfadd");
	sparc_emit_fp_mode_suffix(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_source_register(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_RestoreZero(const ir_node *node) {
	be_emit_cstring("\trestore");
	be_emit_finish_line_gas(node);
}

static void emit_sparc_SetHi(const ir_node *node) {
	be_emit_cstring("\tsethi ");
	sparc_emit_high_immediate(node);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Xor(const ir_node *node) {
	be_emit_cstring("\txor ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Or(const ir_node *node) {
	be_emit_cstring("\tor ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Restore(const ir_node *node) {
	be_emit_cstring("\trestore ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Cmp(const ir_node *node) {
	be_emit_cstring("\tcmp ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fftof(const ir_node *node) {
	be_emit_cstring("\tf");
	sparc_emit_fp_conv_source(node);
	be_emit_cstring("to");
	sparc_emit_fp_conv_destination(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_XNorCCZero(const ir_node *node) {
	be_emit_cstring("\txnorcc ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", %g0");
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Add(const ir_node *node) {
	be_emit_cstring("\tadd ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_SubSP(const ir_node *node) {
	be_emit_cstring("\tsub ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_source_register(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Ldf(const ir_node *node) {
	be_emit_cstring("\tld");
	sparc_emit_float_load_store_mode(node);
	be_emit_cstring(" [");
	sparc_emit_source_register(node, 0);
	sparc_emit_offset(node, 1);
	be_emit_cstring("], ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fdiv(const ir_node *node) {
	be_emit_cstring("\tfdiv");
	sparc_emit_fp_mode_suffix(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_source_register(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_AndN(const ir_node *node) {
	be_emit_cstring("\tandn ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fftoi(const ir_node *node) {
	be_emit_cstring("\tf");
	sparc_emit_fp_mode_suffix(node);
	be_emit_cstring("toi ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_XorCCZero(const ir_node *node) {
	be_emit_cstring("\txorcc ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", %g0");
	be_emit_finish_line_gas(node);
}

static void emit_sparc_St(const ir_node *node) {
	be_emit_cstring("\tst");
	sparc_emit_store_mode(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", [");
	sparc_emit_source_register(node, 1);
	sparc_emit_offset(node, 2);
	be_emit_char(']');
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Save(const ir_node *node) {
	be_emit_cstring("\tsave ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Sub(const ir_node *node) {
	be_emit_cstring("\tsub ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Mul(const ir_node *node) {
	be_emit_cstring("\tsmul ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Stf(const ir_node *node) {
	be_emit_cstring("\tst");
	sparc_emit_float_load_store_mode(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", [");
	sparc_emit_source_register(node, 1);
	sparc_emit_offset(node, 2);
	be_emit_char(']');
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fabs(const ir_node *node) {
	be_emit_cstring("\tfabs ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_OrN(const ir_node *node) {
	be_emit_cstring("\torn ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fcmp(const ir_node *node) {
	be_emit_cstring("\tfcmp");
	sparc_emit_fp_mode_suffix(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_source_register(node, 1);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_AddSP(const ir_node *node) {
	be_emit_cstring("\tadd ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_source_register(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_OrCCZero(const ir_node *node) {
	be_emit_cstring("\torcc ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", %g0");
	be_emit_finish_line_gas(node);
}

static void emit_sparc_AndNCCZero(const ir_node *node) {
	be_emit_cstring("\tandncc ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", %g0");
	be_emit_finish_line_gas(node);
}

static void emit_sparc_XNor(const ir_node *node) {
	be_emit_cstring("\txnor ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_AndCCZero(const ir_node *node) {
	be_emit_cstring("\tandcc ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", %g0");
	be_emit_finish_line_gas(node);
}

static void emit_sparc_And(const ir_node *node) {
	be_emit_cstring("\tand ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_OrNCCZero(const ir_node *node) {
	be_emit_cstring("\torncc ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", %g0");
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fmul(const ir_node *node) {
	be_emit_cstring("\tfmul");
	sparc_emit_fp_mode_suffix(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_source_register(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Sll(const ir_node *node) {
	be_emit_cstring("\tsll ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_Srl(const ir_node *node) {
	be_emit_cstring("\tsrl ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_reg_or_imm(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fneg(const ir_node *node) {
	be_emit_cstring("\tfneg ");
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

static void emit_sparc_fsub(const ir_node *node) {
	be_emit_cstring("\tfsub");
	sparc_emit_fp_mode_suffix(node);
	be_emit_char(' ');
	sparc_emit_source_register(node, 0);
	be_emit_cstring(", ");
	sparc_emit_source_register(node, 1);
	be_emit_cstring(", ");
	sparc_emit_dest_register(node, 0);
	be_emit_finish_line_gas(node);
}

/**
 * Enters the emitter functions for handled nodes into the generic
 * pointer of an opcode.
 */
void sparc_register_spec_emitters(void) {

#define BE_EMIT(a) op_sparc_##a->ops.generic = (op_func)emit_sparc_##a

  /* generated emitter functions */
  BE_EMIT(Sra);
  BE_EMIT(Ld);
  BE_EMIT(fitof);
  BE_EMIT(fadd);
  BE_EMIT(RestoreZero);
  BE_EMIT(SetHi);
  BE_EMIT(Xor);
  BE_EMIT(Or);
  BE_EMIT(Restore);
  BE_EMIT(Cmp);
  BE_EMIT(fftof);
  BE_EMIT(XNorCCZero);
  BE_EMIT(Add);
  BE_EMIT(SubSP);
  BE_EMIT(Ldf);
  BE_EMIT(fdiv);
  BE_EMIT(AndN);
  BE_EMIT(fftoi);
  BE_EMIT(XorCCZero);
  BE_EMIT(St);
  BE_EMIT(Save);
  BE_EMIT(Sub);
  BE_EMIT(Mul);
  BE_EMIT(Stf);
  BE_EMIT(fabs);
  BE_EMIT(OrN);
  BE_EMIT(fcmp);
  BE_EMIT(AddSP);
  BE_EMIT(OrCCZero);
  BE_EMIT(AndNCCZero);
  BE_EMIT(XNor);
  BE_EMIT(AndCCZero);
  BE_EMIT(And);
  BE_EMIT(OrNCCZero);
  BE_EMIT(fmul);
  BE_EMIT(Sll);
  BE_EMIT(Srl);
  BE_EMIT(fneg);
  BE_EMIT(fsub);

#undef BE_EMIT
}

