/* Warning: automatically generated code */
	case iro_Add:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Add(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Alloc:	{
		
		
		ir_type *type = read_type(env);
		
		ir_where_alloc where = (ir_where_alloc) read_long(env);
		newnode = new_r_Alloc(preds[0], preds[1], preds[2], type, where);
		break;
	}
	case iro_And:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_And(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Bad:	{
		
		newnode = new_r_Bad(irg);
		break;
	}
	case iro_Borrow:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Borrow(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Bound:	{
		
		
		op_pin_state state = read_pin_state(env);
		newnode = new_r_Bound(preds[0], preds[1], preds[2], preds[3], preds[4]);
		
		set_irn_pinned(newnode, state);
		break;
	}
	case iro_Builtin:	{
		
		
		ir_builtin_kind kind = read_builtin_kind(env);
		
		ir_type *type = read_type(env);
		
		op_pin_state state = read_pin_state(env);
		newnode = new_r_Builtin(preds[0], preds[1], numpreds - 2, preds + 2, kind, type);
		
		set_irn_pinned(newnode, state);
		break;
	}
	case iro_Call:	{
		
		
		ir_type *type = read_type(env);
		
		unsigned tail_call = read_unsigned(env);
		
		op_pin_state state = read_pin_state(env);
		newnode = new_r_Call(preds[0], preds[1], preds[2], numpreds - 3, preds + 3, type);
		
		set_Call_tail_call(newnode, tail_call);
		
		set_irn_pinned(newnode, state);
		break;
	}
	case iro_Carry:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Carry(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Cast:	{
		
		
		ir_type *type = read_type(env);
		newnode = new_r_Cast(preds[0], preds[1], type);
		break;
	}
	case iro_Cmp:	{
		
		
		ir_relation relation = (ir_relation) read_long(env);
		newnode = new_r_Cmp(preds[0], preds[1], preds[2], relation);
		break;
	}
	case iro_Cond:	{
		
		
		long default_proj = read_long(env);
		
		cond_jmp_predicate jmp_pred = read_cond_jmp_predicate(env);
		newnode = new_r_Cond(preds[0], preds[1]);
		
		set_Cond_default_proj(newnode, default_proj);
		
		set_Cond_jmp_pred(newnode, jmp_pred);
		break;
	}
	case iro_Confirm:	{
		
		
		ir_relation relation = (ir_relation) read_long(env);
		newnode = new_r_Confirm(preds[0], preds[1], preds[2], relation);
		break;
	}
	case iro_Const:	{
		
		
		ir_tarval *tarval = read_tv(env);
		newnode = new_r_Const(irg, tarval);
		break;
	}
	case iro_Conv:	{
		ir_mode *mode = read_mode(env);
		
		int strict = read_int(env);
		newnode = new_r_Conv(preds[0], preds[1], mode);
		
		set_Conv_strict(newnode, strict);
		break;
	}
	case iro_CopyB:	{
		
		
		ir_type *type = read_type(env);
		
		op_pin_state state = read_pin_state(env);
		newnode = new_r_CopyB(preds[0], preds[1], preds[2], preds[3], type);
		
		set_irn_pinned(newnode, state);
		break;
	}
	case iro_Div:	{
		
		
		ir_mode *resmode = read_mode(env);
		
		int no_remainder = read_int(env);
		
		op_pin_state state = read_pin_state(env);
		newnode = new_r_Div(preds[0], preds[1], preds[2], preds[3], resmode, state);
		
		set_Div_no_remainder(newnode, no_remainder);
		break;
	}
	case iro_Dummy:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Dummy(irg, mode);
		break;
	}
	case iro_Eor:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Eor(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Free:	{
		
		
		ir_type *type = read_type(env);
		
		ir_where_alloc where = (ir_where_alloc) read_long(env);
		newnode = new_r_Free(preds[0], preds[1], preds[2], preds[3], type, where);
		break;
	}
	case iro_IJmp:	{
		
		newnode = new_r_IJmp(preds[0], preds[1]);
		break;
	}
	case iro_Id:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Id(preds[0], preds[1], mode);
		break;
	}
	case iro_InstOf:	{
		
		
		ir_type *type = read_type(env);
		
		op_pin_state state = read_pin_state(env);
		newnode = new_r_InstOf(preds[0], preds[1], preds[2], type);
		
		set_irn_pinned(newnode, state);
		break;
	}
	case iro_Jmp:	{
		
		newnode = new_r_Jmp(preds[0]);
		break;
	}
	case iro_Load:	{
		
		
		ir_mode *mode = read_mode(env);
		
		ir_volatility volatility = read_volatility(env);
		
		ir_align unaligned = read_align(env);
		
		op_pin_state state = read_pin_state(env);
		
		ir_cons_flags flags = get_cons_flags(env);
		newnode = new_r_Load(preds[0], preds[1], preds[2], mode, flags);
		
		set_Load_volatility(newnode, volatility);
		
		set_Load_unaligned(newnode, unaligned);
		
		set_irn_pinned(newnode, state);
		break;
	}
	case iro_Minus:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Minus(preds[0], preds[1], mode);
		break;
	}
	case iro_Mod:	{
		
		
		ir_mode *resmode = read_mode(env);
		
		op_pin_state state = read_pin_state(env);
		newnode = new_r_Mod(preds[0], preds[1], preds[2], preds[3], resmode, state);
		break;
	}
	case iro_Mul:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Mul(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Mulh:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Mulh(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Mux:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Mux(preds[0], preds[1], preds[2], preds[3], mode);
		break;
	}
	case iro_NoMem:	{
		
		newnode = new_r_NoMem(irg);
		break;
	}
	case iro_Not:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Not(preds[0], preds[1], mode);
		break;
	}
	case iro_Or:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Or(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Phi:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Phi(preds[0], numpreds - 1, preds + 1, mode);
		break;
	}
	case iro_Pin:	{
		
		newnode = new_r_Pin(preds[0], preds[1]);
		break;
	}
	case iro_Raise:	{
		
		newnode = new_r_Raise(preds[0], preds[1], preds[2]);
		break;
	}
	case iro_Return:	{
		
		newnode = new_r_Return(preds[0], preds[1], numpreds - 2, preds + 2);
		break;
	}
	case iro_Rotl:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Rotl(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Sel:	{
		
		
		ir_entity *entity = read_entity(env);
		newnode = new_r_Sel(preds[0], preds[1], preds[2], numpreds - 3, preds + 3, entity);
		break;
	}
	case iro_Shl:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Shl(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Shr:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Shr(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Shrs:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Shrs(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Store:	{
		
		
		ir_volatility volatility = read_volatility(env);
		
		ir_align unaligned = read_align(env);
		
		op_pin_state state = read_pin_state(env);
		
		ir_cons_flags flags = get_cons_flags(env);
		newnode = new_r_Store(preds[0], preds[1], preds[2], preds[3], flags);
		
		set_Store_volatility(newnode, volatility);
		
		set_Store_unaligned(newnode, unaligned);
		
		set_irn_pinned(newnode, state);
		break;
	}
	case iro_Sub:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Sub(preds[0], preds[1], preds[2], mode);
		break;
	}
	case iro_Sync:	{
		
		newnode = new_r_Sync(preds[0], numpreds - 1, preds + 1);
		break;
	}
	case iro_Tuple:	{
		
		newnode = new_r_Tuple(preds[0], numpreds - 1, preds + 1);
		break;
	}
	case iro_Unknown:	{
		ir_mode *mode = read_mode(env);
		newnode = new_r_Unknown(irg, mode);
		break;
	}
